diff --git a/gnome-session/gsm-fail-whale.c b/gnome-session/gsm-fail-whale.c
new file mode 100644
index 00000000..a0304f28
--- /dev/null
+++ b/gnome-session/gsm-fail-whale.c
@@ -0,0 +1,66 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ * gsm-fail-whale.c
+ * Copyright (C) 2012 Red Hat, Inc
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#include <config.h>
+
+#include <signal.h>
+#include <stdlib.h>
+
+#include <glib/gi18n.h>
+#include <glib/gstdio.h>
+
+#include "gsm-fail-whale.h"
+#include "gsm-util.h"
+
+static void
+on_fail_whale_failed (void)
+{
+        raise (SIGTERM);
+}
+
+void
+gsm_fail_whale_dialog_we_failed  (gboolean            debug_mode,
+                                  gboolean            allow_logout,
+                                  GsmShellExtensions *extensions)
+{
+        gint i;
+        gchar *argv[5];
+        static GPid pid = 0;
+
+        if (pid != 0) {
+                return;
+        }
+
+        i = 0;
+        argv[i++] = LIBEXECDIR "/gnome-session-failed";
+        if (debug_mode)
+                argv[i++] = "--debug";
+        if (allow_logout)
+                argv[i++] = "--allow-logout";
+        if (extensions != NULL && gsm_shell_extensions_n_extensions (extensions) > 0)
+                argv[i++] = "--extensions";
+        argv[i++] = NULL;
+
+        if (!g_spawn_async (NULL, argv, (char **) gsm_util_listenv (), G_SPAWN_DO_NOT_REAP_CHILD, NULL, NULL, &pid, NULL)) {
+                exit (1);
+        }
+
+        g_child_watch_add (pid,
+                           (GChildWatchFunc)on_fail_whale_failed,
+                           NULL);
+}
diff --git a/gnome-session/gsm-fail-whale.h b/gnome-session/gsm-fail-whale.h
new file mode 100644
index 00000000..5b93dcab
--- /dev/null
+++ b/gnome-session/gsm-fail-whale.h
@@ -0,0 +1,34 @@
+/* gsm-fail-whale.h
+ * Copyright (C) 2012 Red Hat, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __GSM_FAIL_WHALE_H__
+#define __GSM_FAIL_WHALE_H__
+
+#include <glib.h>
+
+#include "gsm-shell-extensions.h"
+
+G_BEGIN_DECLS
+
+void        gsm_fail_whale_dialog_we_failed  (gboolean            debug_mode,
+                                              gboolean            allow_logout,
+                                              GsmShellExtensions *extensions);
+
+G_END_DECLS
+
+#endif /* __GSM_FAIL_WHALE_H__ */
+
diff --git a/gnome-session/gsm-icon-names.h b/gnome-session/gsm-icon-names.h
new file mode 100644
index 00000000..82f28345
--- /dev/null
+++ b/gnome-session/gsm-icon-names.h
@@ -0,0 +1,28 @@
+/* -*- Mode: C; tab-width: 8; indent-tabs-mode: nil; c-basic-offset: 8 -*-
+ *
+ * Copyright (C) 2011 Novell, Inc.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, see <http://www.gnu.org/licenses/>.
+ */
+
+#ifndef __GSM_ICON_NAMES_H__
+#define __GSM_ICON_NAMES_H__
+
+#define GSM_ICON_COMPUTER_FAIL       "computer-fail-symbolic"
+#define GSM_ICON_INHIBITOR_DEFAULT   "gnome-windows"
+#define GSM_ICON_LOGOUT              "system-log-out"
+#define GSM_ICON_SHUTDOWN            "system-shutdown"
+#define GSM_ICON_XSMP_DEFAULT        "system-run"
+
+#endif /*__GSM_ICON_NAMES_H__ */
diff --git a/gnome-session/gsm-inhibitor.c b/gnome-session/gsm-inhibitor.c
index f1768578..13440beb 100644
--- a/gnome-session/gsm-inhibitor.c
+++ b/gnome-session/gsm-inhibitor.c
@@ -39,6 +39,7 @@ struct GsmInhibitorPrivate
         char *client_id;
         char *reason;
         guint flags;
+        guint toplevel_xid;
         guint cookie;
         GDBusConnection *connection;
         GsmExportedInhibitor *skeleton;
@@ -53,6 +54,7 @@ enum {
         PROP_APP_ID,
         PROP_CLIENT_ID,
         PROP_FLAGS,
+        PROP_TOPLEVEL_XID,
         PROP_COOKIE
 };
 
@@ -148,6 +150,15 @@ gsm_inhibitor_get_flags (GsmExportedInhibitor  *skeleton,
         return TRUE;
 }
 
+static gboolean
+gsm_inhibitor_get_toplevel_xid (GsmExportedInhibitor  *skeleton,
+                                GDBusMethodInvocation *invocation,
+                                GsmInhibitor          *inhibitor)
+{
+        gsm_exported_inhibitor_complete_get_toplevel_xid (skeleton, invocation, inhibitor->priv->toplevel_xid);
+        return TRUE;
+}
+
 static guint32
 get_next_inhibitor_serial (void)
 {
@@ -197,6 +208,8 @@ register_inhibitor (GsmInhibitor *inhibitor)
                           G_CALLBACK (gsm_inhibitor_get_flags), inhibitor);
         g_signal_connect (skeleton, "handle-get-reason",
                           G_CALLBACK (gsm_inhibitor_get_reason), inhibitor);
+        g_signal_connect (skeleton, "handle-get-toplevel-xid",
+                          G_CALLBACK (gsm_inhibitor_get_toplevel_xid), inhibitor);
 
         return TRUE;
 }
@@ -336,6 +349,18 @@ gsm_inhibitor_set_flags (GsmInhibitor  *inhibitor,
         }
 }
 
+static void
+gsm_inhibitor_set_toplevel_xid (GsmInhibitor  *inhibitor,
+                                guint          xid)
+{
+        g_return_if_fail (GSM_IS_INHIBITOR (inhibitor));
+
+        if (inhibitor->priv->toplevel_xid != xid) {
+                inhibitor->priv->toplevel_xid = xid;
+                g_object_notify (G_OBJECT (inhibitor), "toplevel-xid");
+        }
+}
+
 const char *
 gsm_inhibitor_peek_bus_name (GsmInhibitor  *inhibitor)
 {
@@ -384,6 +409,14 @@ gsm_inhibitor_peek_flags (GsmInhibitor  *inhibitor)
         return inhibitor->priv->flags;
 }
 
+guint
+gsm_inhibitor_peek_toplevel_xid (GsmInhibitor  *inhibitor)
+{
+        g_return_val_if_fail (GSM_IS_INHIBITOR (inhibitor), 0);
+
+        return inhibitor->priv->toplevel_xid;
+}
+
 guint
 gsm_inhibitor_peek_cookie (GsmInhibitor  *inhibitor)
 {
@@ -421,6 +454,9 @@ gsm_inhibitor_set_property (GObject       *object,
         case PROP_COOKIE:
                 gsm_inhibitor_set_cookie (self, g_value_get_uint (value));
                 break;
+        case PROP_TOPLEVEL_XID:
+                gsm_inhibitor_set_toplevel_xid (self, g_value_get_uint (value));
+                break;
         default:
                 G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
                 break;
@@ -456,6 +492,9 @@ gsm_inhibitor_get_property (GObject    *object,
         case PROP_COOKIE:
                 g_value_set_uint (value, self->priv->cookie);
                 break;
+        case PROP_TOPLEVEL_XID:
+                g_value_set_uint (value, self->priv->toplevel_xid);
+                break;
         default:
                 G_OBJECT_WARN_INVALID_PROPERTY_ID (object, prop_id, pspec);
                 break;
@@ -542,6 +581,15 @@ gsm_inhibitor_class_init (GsmInhibitorClass *klass)
                                                             G_MAXINT,
                                                             0,
                                                             G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
+        g_object_class_install_property (object_class,
+                                         PROP_TOPLEVEL_XID,
+                                         g_param_spec_uint ("toplevel-xid",
+                                                            "toplevel-xid",
+                                                            "toplevel-xid",
+                                                            0,
+                                                            G_MAXINT,
+                                                            0,
+                                                            G_PARAM_READWRITE | G_PARAM_CONSTRUCT));
         g_object_class_install_property (object_class,
                                          PROP_COOKIE,
                                          g_param_spec_uint ("cookie",
@@ -555,6 +603,7 @@ gsm_inhibitor_class_init (GsmInhibitorClass *klass)
 
 GsmInhibitor *
 gsm_inhibitor_new (const char    *app_id,
+                   guint          toplevel_xid,
                    guint          flags,
                    const char    *reason,
                    const char    *bus_name,
@@ -567,6 +616,7 @@ gsm_inhibitor_new (const char    *app_id,
                                   "reason", reason,
                                   "bus-name", bus_name,
                                   "flags", flags,
+                                  "toplevel-xid", toplevel_xid,
                                   "cookie", cookie,
                                   NULL);
 
diff --git a/gnome-session/gsm-inhibitor.h b/gnome-session/gsm-inhibitor.h
index 7b50271d..519b70cf 100644
--- a/gnome-session/gsm-inhibitor.h
+++ b/gnome-session/gsm-inhibitor.h
@@ -62,6 +62,7 @@ GQuark         gsm_inhibitor_error_quark          (void);
 GType          gsm_inhibitor_get_type             (void) G_GNUC_CONST;
 
 GsmInhibitor * gsm_inhibitor_new                  (const char    *app_id,
+                                                   guint          toplevel_xid,
                                                    guint          flags,
                                                    const char    *reason,
                                                    const char    *bus_name,
@@ -80,6 +81,7 @@ const char *   gsm_inhibitor_peek_reason          (GsmInhibitor  *inhibitor);
 const char *   gsm_inhibitor_peek_bus_name        (GsmInhibitor  *inhibitor);
 guint          gsm_inhibitor_peek_cookie          (GsmInhibitor  *inhibitor);
 guint          gsm_inhibitor_peek_flags           (GsmInhibitor  *inhibitor);
+guint          gsm_inhibitor_peek_toplevel_xid    (GsmInhibitor  *inhibitor);
 
 G_END_DECLS
 
